package com.pj.biz;

import java.util.List;

import com.pj.project.tb_gate_command_log.TbGateCommandLog;
import com.pj.project.tb_gate_command_log.TbGateCommandLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.utils.so.*;
import com.pj.project4sp.SP;

import com.pj.current.satoken.StpUserUtil;
import cn.dev33.satoken.annotation.SaCheckPermission;


/**
 * Controller: tb_gate_command_log -- 车辆道闸命令日志
 *
 * @author qzyReal
 */
@RestController
@RequestMapping("/TbGateCommandLog/")
public class TbGateCommandLogController {

    /**
     * 底层 Service 对象
     */
    @Autowired
    TbGateCommandLogService tbGateCommandLogService;


    /**
     * 删
     */
    @RequestMapping("delete")
    @SaCheckPermission(TbGateCommandLog.PERMISSION_CODE_DEL)
    public AjaxJson delete(Long id) {
        tbGateCommandLogService.delete(id);
        return AjaxJson.getSuccess();
    }

    /**
     * 删 - 根据id列表
     */
    @RequestMapping("deleteByIds")
    @SaCheckPermission(TbGateCommandLog.PERMISSION_CODE_DEL)
    public AjaxJson deleteByIds() {
        List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
        int line = SP.publicMapper.deleteByIds(TbGateCommandLog.TABLE_NAME, ids);
        return AjaxJson.getByLine(line);
    }



    /**
     * 查 - 根据id
     */
    @RequestMapping("getById")
    public AjaxJson getById(Long id) {
        TbGateCommandLog t = tbGateCommandLogService.getById(id);
        return AjaxJson.getSuccessData(t);
    }

    /**
     * 查集合 - 根据条件（参数为空时代表忽略指定条件）
     */
    @RequestMapping("getList")
    public AjaxJson getList() {
        SoMap so = SoMap.getRequestSoMap();
        List<TbGateCommandLog> list = tbGateCommandLogService.getList(so.startPage());
        return AjaxJson.getPageData(so.getDataCount(), list);
    }


}
