package com.pj.project.tb_mini_user;

import java.util.List;

import cn.dev33.satoken.stp.StpUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pj.current.satoken.StpUserUtil;
import com.pj.utils.sg.AjaxJson;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.pj.utils.so.*;

import javax.annotation.Resource;

/**
 * Service: tb_mini_user -- h5端用户
 *
 * @author qzyReal
 */
@Service
public class TbMiniUserService extends ServiceImpl<TbMiniUserMapper, TbMiniUser> implements IService<TbMiniUser> {

    /**
     * 底层 Mapper 对象
     */
    @Autowired
    TbMiniUserMapper tbMiniUserMapper;


    /**
     * 增
     */
    public void add(TbMiniUser t) {
        this.save(t);
    }

    /**
     * 删
     */
    public void delete(Long id) {
        this.removeById(id);
    }

    /**
     * 改
     */
    public void update(TbMiniUser t) {
        this.updateById(t);
    }

    /**
     * 查
     */
    public TbMiniUser getById(Long id) {
        return super.getById(id);
    }

    /**
     * 查集合 - 根据条件（参数为空时代表忽略指定条件）
     */
    public List<TbMiniUser> getList(SoMap so) {
        return tbMiniUserMapper.getList(so);
    }


    public TbMiniUser findByOpenid(String openid) {
        QueryWrapper<TbMiniUser> ew = new QueryWrapper<>();
        ew.lambda().eq(TbMiniUser::getOpenid, openid);
        return getOne(ew);
    }


    public void removeByPhone(String phone) {
        QueryWrapper<TbMiniUser> ew = new QueryWrapper<>();
        ew.lambda().eq(TbMiniUser::getPhone, phone);
        this.remove(ew);
    }

    public AjaxJson loginByOpenid(String openid) {
        TbMiniUser tbMiniUser = this.findByOpenid(openid);
        if (tbMiniUser == null) {
            return AjaxJson.getError("用户不存在");
        }
        StpUtil.login(tbMiniUser.getSpAdminId());
        tbMiniUser.setToken(StpUtil.getTokenValue());
        StpUserUtil.setDeptId(tbMiniUser.getDeptId() + "");
        StpUserUtil.setAdmin(tbMiniUser.getName(), tbMiniUser.getPhone());
        StpUserUtil.setMiniUserId(tbMiniUser.getId());
        return AjaxJson.getSuccessData(tbMiniUser);
    }
}
