package com.pj.project.tb_person_black.task;

import com.pj.project.tb_person_black.TbPersonBlack;
import com.pj.project.tb_person_black.TbPersonBlackService;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.scheduling.annotation.Scheduled;

import javax.annotation.Resource;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

@Data
@Accessors(chain = true)
public class PersonBlackTask implements Serializable {

    @Resource
    private TbPersonBlackService tbPersonBlackService;

    @Scheduled(fixedRate = 45000)
    public void task() {
        //提前5分钟下发黑名单
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd hh:mm");
        LocalDateTime fiveMinutes = LocalDateTime.now().minusMinutes(5);
        LocalDateTime sixMinutes = fiveMinutes.minusMinutes(1);
        List<TbPersonBlack> personBlacks = tbPersonBlackService.finRecordStartTimeInTimes(sixMinutes.format(formatter), fiveMinutes.format(formatter));
        personBlacks.forEach(tbPersonBlack -> {
            tbPersonBlackService.issued(tbPersonBlack);
        });
        //5分钟之后删除
        List<TbPersonBlack> deleteList = tbPersonBlackService.finRecordEndTimeInTimes(sixMinutes.format(formatter), fiveMinutes.format(formatter));
        deleteList.forEach(tbPersonBlack -> tbPersonBlackService.deleteTerminalBlack(tbPersonBlack));
    }
}
